<template>
  <div
    :class="classes"
    class="CeGrid"
  >
    <div
      v-for="(column, index) in structure.rows[0].columns"
      :key="`grid-cell-${index}`"
      class="CeGrid-cell"
    >
      <ContentElement
        v-for="(contentElement, innerIndex) in column.elements"
        :key="`content-section-${innerIndex}`"
        :data="contentElement"
        outer-spacing-horizontal="none"
      />
    </div>
  </div>
</template>

<script>
export default {
  name: 'CeGrid',

  components: {
    ContentElement: () => import('../ContentElement')
  },

  props: {
    structure: {
      type: Object,
      required: true
    }
  },

  computed: {
    classes () {
      const classes = []

      if (this.structure.layout !== undefined) {
        classes.push(this.$options.name + '--columns' + this.structure.layout)
      }

      return classes
    }
  }
}
</script>

<style scoped>
.CeGrid {
  display: grid;
  grid-template-columns: 100%;
  grid-template-rows: auto;
  grid-gap: 15px;
}

.CeGrid-cell {
  display: block;
}

@media (min-width: 640px) {
  .CeGrid--columns25-25-25-25 {
    grid-template-columns: 1fr 1fr;
  }

  .CeGrid--columns33-66 {
    grid-template-columns: 1fr 2fr;
  }

  .CeGrid--columns50-50 {
    grid-template-columns: 1fr 1fr;
  }
}

@media (min-width: 992px) {
  .CeGrid--columns25-25-25-25 {
    grid-template-columns: 1fr 1fr 1fr 1fr;
  }
}
</style>
